package bytecode;

import static org.junit.Assert.assertEquals;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class OLFunTest {
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@Test
	public void generateBC() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/OLFun.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		compiler.generateBytecode(System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/");
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("OLFun");
		/*
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();

		Method m = classToTest.getDeclaredMethod("m");
		Class<?> lambda = m.invoke(instanceOfClass).getClass();
		Method apply = lambda.getMethod("apply", Object.class);

		// Damit man auf die Methode zugreifen kann
		apply.setAccessible(true);

		Integer i = 77;
		
		Integer result = (Integer) apply.invoke(m.invoke(instanceOfClass), i); 

		assertEquals(77, result);
		*/
	}


}
